USE $(DBNAME)
 GO
CREATE SCHEMA AUTHORIZATION CONFIG
GO

CREATE TABLE CONFIG.MODULES(
	MODULE_ID INT  NOT NULL,
	MODULE NVARCHAR(255),
	SUB_MODULE_ID INT  NOT NULL,
	SUB_MODULE NVARCHAR(255),
	MODIFY NVARCHAR(255),
	REC_DATETIME DATETIME DEFAULT GETDATE() 
) ON VNF_32K 
GO




CREATE TABLE CONFIG.STATEMENT_LIST(
	STATEMENT_NUMBER INT  NOT NULL,
	MODULE_ID INT ,
	SUB_MODULE_ID INT ,
	AREA NVARCHAR(255),
	TYPE NVARCHAR(255),
	ACTION NVARCHAR(255),
	UOW_ID INT ,
	DATA_MOVEMENT INT ,
	TABLE_REFACTORING INT ,
	DESCRIPTION NVARCHAR(1000),
	AFFECTED_TABLE NVARCHAR(255),
    AFFECTED_SCHEMA NVARCHAR(255),
	OBJECT_TYPE NVARCHAR(255),
	OBJECT_NAME NVARCHAR(255),
	PRE_EXISTS INT ,
	RECOVERABLE INT ,
	HAS_DEPENDENCIES INT ,
	EXECUTION_STATUS INT ,
	[EXECUTE] INT ,
	RELEASE NVARCHAR(255),
	SPECIAL_RELEASE NVARCHAR(255),
	[TEXT] NVARCHAR(4000),
	RET_CODE NVARCHAR(255),
	REC_DATETIME DATETIME DEFAULT GETDATE() 
) ON VNF_32K 
GO



CREATE TABLE CONFIG.STATEMENT_DEPENDENCIES(
	STATEMENT_NUMBER INT ,
	PREDECESSOR_NUMBER INT 
) ON VNF_32K 
GO




CREATE TABLE CONFIG.REFACTOR_TABLE(
STATEMENT_NUMBER INT ,
STEP_NUMBER INT ,
ACTION NVARCHAR(255),
OBJECT_TYPE NVARCHAR(255),
OBJECT_NAME NVARCHAR(255),
PRE_EXISTS NVARCHAR(255),
[TEXT] NVARCHAR(4000),
REC_DATETIME DATETIME DEFAULT GETDATE() 
)ON VNF_32K 
GO

