@ECHO off
rem ******************************************************************************************************************************
rem * Licensed Materials - Property of IBM                                                                                       *
rem * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
rem *                                                                                                                            *
rem *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
rem ******************************************************************************************************************************

IF NOT DEFINED LOCALE (SET LOCALE= )

SET LOCEN=0409
SET LOCIT=0410 
SET LOCJP=0411 
SET LOCKO=0412 
SET LOCPO=0415 
SET LOCCHS=0804
SET LOCCHT=0404

IF NOT DEFINED SQLSERVINST (SET SQLSERVINST= )
IF NOT DEFINED DBNAME      (SET DBNAME= ) 
IF NOT DEFINED NF_SCHEMA   (SET NF_SCHEMA= ) 
IF NOT DEFINED STAR_SCHEMA (SET STAR_SCHEMA= ) 
IF NOT DEFINED REP_USER    (SET REP_USER= ) 
IF NOT DEFINED DATA_HOME   (SET DATA_HOME= ) 
IF NOT DEFINED MSSQL_HOME  (SET MSSQL_HOME= ) 
IF NOT DEFINED START_YEAR  (SET START_YEAR= ) 
IF NOT DEFINED END_YEAR    (SET END_YEAR= ) 
IF NOT DEFINED JAVA_HOME (SET JAVA_HOME= )
IF NOT DEFINED VIEW_REDEF (SET IF NOT DEFINED= )



SET EXITCODE=0
SET MESSAGE= xxx

IF NOT EXIST set_env.bat (
                           SET EXITCODE=4597 
                           GOTO done
                                    ) ELSE (                
                       call set_env.bat
                                  )



IF "%JAVA_HOME%" EQU " " (
SET EXITCODE= 4596 
GOTO done)  


SET CURDIR=%CD%

CD /d "%JAVA_HOME%\bin"
IF "%ERRORLEVEL%" EQU "1" (
SET EXITCODE=4596
GOTO done)

IF NOT EXIST java.exe (
SET EXITCODE= 4598
GOTO done   ) 

CD /d %CURDIR%

set path=%JAVA_HOME%\bin;%path%



REG QUERY "HKCU\Control Panel\International" /v Locale>locale.txt

java com.ibm.rational.vega.dw.SearchAndReplace %LOCIT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCIT%
call lang\it\messages.bat) 
java com.ibm.rational.vega.dw.SearchAndReplace %LOCJP% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCJP%
call lang\jp\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCKO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCKO%
call lang\kr\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCPO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCPO%
call lang\pl\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHS% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHS%
call lang\zh_CN\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHT%
call lang\zh_TW\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCEN% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCEN%
call lang\en\messages.bat)

IF "%LOCALE%" EQU " " (
SET LOCALE=%LOCEN%
call lang\en\messages.bat)

IF "%1" EQU "-validate" (GOTO validate)



SET EXITCODE=0
SET MESSAGE=No errors


SET /A SILENT=0
IF "%1" EQU "-silent" (
SET /A SILENT=1) 

SET MSSQL_CMD=
IF "%1" EQU "-debug" (SET MSSQL_CMD= -b -l 60 -e ) ELSE (SET MSSQL_CMD= -b -l 60 )
IF "%2" NEQ "" (IF "%2" EQU "-debug" (SET MSSQL_CMD= -b -l 60 -e ) ELSE (SET MSSQL_CMD= -b -l 60 ))

ECHO %CRREWECH033%

IF %SILENT% EQU 0 (
SET /P SQLSERVINST=%CRREWPRMPT023%
)
IF "%SQLSERVINST%" NEQ " " (SET SQLSERVINST=%COMPUTERNAME%\%SQLSERVINST%) ELSE (SET SQLSERVINST=%COMPUTERNAME%)

IF %SILENT% EQU 0 (
SET /P DBNAME=%CRREWPRMPT028%
)
IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done) 

IF %SILENT% EQU 0 (
SET /P NF_SCHEMA=%CRREWPRMPT029%
)
IF "%NF_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF %SILENT% EQU 0 (
SET /P STAR_SCHEMA=%CRREWPRMPT030%
)
IF "%STAR_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF %SILENT% EQU 0 (
SET /P REP_USER=%CRREWPRMPT031%
)
IF "%REP_USER%" EQU " " (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF %SILENT% EQU 0 (
SET /P VIEW_REDEF=%CRREWPRMPT032%
)
IF "%VIEW_REDEF%" EQU " " (
SET VIEW_REDEF=0)

IF "%VIEW_REDEF%" NEQ "1" (
SET VIEW_REDEF=0)


IF NOT EXIST work_spc\nul (MKDIR work_spc) ELSE (
RMDIR /S /Q work_spc
MKDIR work_spc
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)
IF NOT EXIST logs\nul (MKDIR logs) ELSE (
RMDIR /S /Q logs
MKDIR logs
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

XCOPY /Y /I /E /Q ddl work_spc\ddl
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)

XCOPY /Y /I /E /Q scripts work_spc\scripts
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)

sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.DW_MIGRATE') IS NOT NULL ) drop procedure %USERNAME%.DW_MIGRATE"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.MIGRATE_MODULE') IS NOT NULL ) drop procedure %USERNAME%.MIGRATE_MODULE"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.PROCESS_UOW') IS NOT NULL ) drop procedure %USERNAME%.PROCESS_UOW"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.VALIDATE_EXISTENCE') IS NOT NULL ) drop procedure %USERNAME%.VALIDATE_EXISTENCE"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.REPLACE_SCHEMA') IS NOT NULL ) drop function %USERNAME%.REPLACE_SCHEMA"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.PROCESS_ALL_CONSTR') IS NOT NULL ) drop procedure %USERNAME%.PROCESS_ALL_CONSTR"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.PROCESS_IMPLICIT_CONSTR') IS NOT NULL ) drop procedure %USERNAME%.PROCESS_IMPLICIT_CONSTR"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.GET_REFERENCE_DEFINE') IS NOT NULL ) drop procedure %USERNAME%.GET_REFERENCE_DEFINE"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.GET_IDXCOL_LIST') IS NOT NULL ) drop function %USERNAME%.GET_IDXCOL_LIST"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.GET_INDEX_DEFINE') IS NOT NULL ) drop procedure %USERNAME%.GET_INDEX_DEFINE"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.GET_DEFAULT_CONSTR') IS NOT NULL ) drop procedure %USERNAME%.GET_DEFAULT_CONSTR"
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "IF (object_id('%USERNAME%.PROCESS_COLUMN_UPDATE') IS NOT NULL ) drop procedure %USERNAME%.PROCESS_COLUMN_UPDATE"

FOR /F "usebackq delims==" %%g IN (`sqlcmd -S %SQLSERVINST% -d %DBNAME% -b -l 60 -h -1 -Q "SET NOCOUNT ON; SELECT COUNT(*) FROM sys.tables WHERE NAME IN ('MODULES','STATEMENT_LIST','STATEMENT_DEPENDENCIES');"`) do (set EXISTS=%%g)      
SET EXISTS=%EXISTS: =%
IF "%EXISTS: =%" EQU "0" (
sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" %MSSQL_CMD% -i "%CD%"\work_spc\ddl\createMIG.ddl>logs\createMIG.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\createMIG.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE016%  
SET EXITCODE=%CRREW4516E%
ECHO %CRREWECH006%
GOTO done)
)

FOR /F "usebackq delims==" %%g IN (`sqlcmd -S %SQLSERVINST% -d %DBNAME% -b -l 60 -h -1 -Q "SET NOCOUNT ON; SELECT COUNT(*) FROM sys.schemas WHERE NAME ='%USERNAME%';"`) do (set EXISTS=%%g)      
SET EXISTS=%EXISTS: =%
IF "%EXISTS: =%" EQU "0" (
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "CREATE SCHEMA %USERNAME%"
)


sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" CURRENT_USER="%USERNAME%" %MSSQL_CMD% -i "%CD%"\work_spc\scripts\statements.sql>logs\statements.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\statements.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE020%  
SET EXITCODE=%CRREW4520E%
ECHO %CRREWECH010%
GOTO done)

IF "%VIEW_REDEF%" EQU "1" (
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "UPDATE CONFIG.STATEMENT_LIST SET [EXECUTE]=1 WHERE RTRIM(ACTION)='ALTER VIEW'">nul )

sqlcmd -S %SQLSERVINST% -v DBNAME="%DBNAME%" CURRENT_SCHEMA="%USERNAME%" CRREWMSGE098="%CRREWMSGE098%" CRREWMSGE099="%CRREWMSGE099%" CRREWMSGE101="%CRREWMSGE101%" CRREWMSGE102="%CRREWMSGE102%" CRREWMSGE005="%CRREWMSGE005%" CRREWMSGE006="%CRREWMSGE006%" CRREWMSGE007="%CRREWMSGE007%" %MSSQL_CMD% -i "%CD%"\work_spc\scripts\migration_sp.sql>logs\migration_sp.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\migration_sp.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE104%  
SET EXITCODE=%CRREW4604E% 
GOTO done) 

sqlcmd -S %SQLSERVINST% -d %DBNAME% -v CURRENT_SCHEMA="%USERNAME%" %MSSQL_CMD% -Q "$(USERNAME).DW_MIGRATE @ODS_SCHEMA=$(NF_SCHEMA),@DM_SCHEMA=$(STAR_SCHEMA),@REP_USER=$(REP_USER)" >>logs\migrateDB.log
java com.ibm.rational.vega.dw.SearchAndReplace Msg "%CD%"\logs\migrateDB.log>nul
IF "%ERRORLEVEL%" EQU "1" (
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "SELECT STATEMENT_NUMBER, EXECUTION_STATUS, RET_CODE,[TEXT] FROM CONFIG.STATEMENT_LIST WHERE EXECUTION_STATUS=0" >logs\failed_statements.log
SET MESSAGE=%CRREWMSGE103%  
SET EXITCODE=%CRREW4603E% 
GOTO done)
sqlcmd -S %SQLSERVINST% -d %DBNAME% %MSSQL_CMD% -Q "SELECT STATEMENT_NUMBER, EXECUTION_STATUS, RET_CODE,[TEXT] FROM CONFIG.STATEMENT_LIST WHERE EXECUTION_STATUS=0" >logs\failed_statements.log

GOTO done

:done 
echo %MESSAGE%:%EXITCODE%
echo %CRREWECH002%
EXIT /B %EXITCODE%
